#pragma once

#include <stddef.h>

#include "ferrumhook/ferrum-dll.h"
#include "ferrumhook/xinput.h"
#include "ferrumhook/jvs.h"
#include "ferrumhook/network.h"

#include "platform/config.h"
#include "gfxhook/config.h"
#include "amcus/config.h"

struct ferrum_hook_config {
    struct platform_config platform;
    struct ferrum_dll_config dll;
    struct ferrum_xinput_config xinput;
    struct gfx_config gfx;
    struct amcus_config amcus;
    struct ferrum_network_config network;
};

void ferrum_dll_config_load(
    struct ferrum_dll_config *cfg,
    const wchar_t *filename);

void ferrum_xinput_config_load(
    struct ferrum_xinput_config *cfg,
    const wchar_t *filename);

void ferrum_network_config_load(
    struct ferrum_network_config *cfg,
    const wchar_t *filename);

void ferrum_hook_config_load(
    struct ferrum_hook_config *cfg,
    const wchar_t *filename);

