#pragma once

#include <stddef.h>

#include "taikohook/taiko-dll.h"
#include "taikohook/bnusio.h"
#include "taikohook/qr.h"
#include "taikohook/network.h"

#include "platform/config.h"
#include "gfxhook/config.h"
#include "amcus/config.h"

struct taiko_hook_config {
    struct platform_config platform;
    struct taiko_dll_config dll;
    struct bnusio_config bnusio;
    struct gfx_config gfx;
    struct amcus_config amcus;
    struct qr_config qr;
    struct ferrum_network_config network;
};

void taiko_dll_config_load(
    struct taiko_dll_config *cfg,
    const wchar_t *filename);

void bnusio_config_load(
    struct bnusio_config *cfg,
    const wchar_t *filename);

void qr_config_load(
    struct qr_config *cfg,
    const wchar_t *filename);

void network_config_load(
    struct ferrum_network_config *cfg,
    const wchar_t *filename);

void taiko_hook_config_load(
    struct taiko_hook_config *cfg,
    const wchar_t *filename);

